//-----------------------------------------
// LScript Modeler Interactive Julienne
//
// Copyright 2005 Michael Green
// MikesLscripts@shortbutpurple.fsnet.co.uk
//

myversion=1.3;

// V1.3
//Fixed division by zero error.
// V1.2
// fixed undo bug.
// v1.1
// fixed bug with curves.

@version 2.2
@warnings
@script modeler

// global values go here
c0,c1;
mybbox;
mypolys;
myfg;
mybg;
myundo=0;

main
{
    myfg=lyrfg();
    mybgs=lyrempty();
    mybg=mybgs[1];
    if(myfg.size()>1)
    {
        error("Use on one layer only please");
    }

    myslices    =   recall("MGInterJulienneSlices",5);
    myaxis      =   recall("MGInterJulienneAxis",1);

    selmode(USER);
    editbegin();
        mybbox=boundingbox();
        mychosenpolys=polygons;
        j=1;
        for(i=1;i<=mychosenpolys.size();i++)
        {
            if(!mychosenpolys[i].isCurve() && mychosenpolys[i].pointCount>2)
            {
                mypolys[j]=mychosenpolys[i];
                j++;
            }
        }
        if(!mypolys)
            error("Please choose one or more polygons");
    editend();

    // requester code goes here

    reqbegin("MG Julienne Interactive Ver:"+myversion);

    c0 = ctlminislider("Number of slices",myslices,2,100);
    c1 = ctlchoice("Axis",myaxis,@"X","Y","Z"@);

    myrefresh(0);

    ctlrefresh(c0,"myrefresh");
    ctlrefresh(c1,"myrefresh");

    if (!reqpost())
    {
        if(myundo)
        {
            undo();
            undo();
            undo();
            undo();
        }
        return;
    }

    // get requester control values here

    reqend();

    // processing code goes here


}
myrefresh:value
{
//debug();
    if(myundo)
    {
            undo();         //editbegin
            undo();         //soliddrill
            undo();         //delete
            undo();
    }

    myslices=getvalue(c0);
    myaxis=getvalue(c1);
    if(myslices<2)
    {
    	myslices=2;
    	setvalue(c0,2);
    }

    store("MGInterJulienneSlices",myslices);
    store("MGInterJulienneAxis",myaxis);

    myslice(myaxis,myslices,mybbox,myfg,mybg);
}

myslice:paxis, pslices, pbbox, pfg, pbg
{
    myundo=1;
    mylo=pbbox[1];
    myhi=pbbox[2];
    lyrsetfg(pbg);
    pslices=max(pslices,2);

    switch(paxis)
    {
        case 1:

            interval=(pbbox[2].x - pbbox[1].x)/pslices;
            if(!interval)
            {   
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x+interval*i,mylo.y - 1,mylo.z - 1>);
                    corner2=addpoint(<mylo.x+interval*i,myhi.y + 1,mylo.z - 1>);
                    corner3=addpoint(<mylo.x+interval*i,myhi.y + 1,myhi.z + 1>);
                    corner4=addpoint(<mylo.x+interval*i,mylo.y - 1,myhi.z + 1>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;

        case 2:
            interval=(pbbox[2].y - pbbox[1].y)/pslices;

            if(!interval)
            {
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x - 1,mylo.y +interval*i,mylo.z - 1>);
                    corner2=addpoint(<myhi.x + 1,mylo.y +interval*i,mylo.z - 1>);
                    corner3=addpoint(<myhi.x + 1,mylo.y +interval*i,myhi.z + 1>);
                    corner4=addpoint(<mylo.x - 1,mylo.y +interval*i,myhi.z + 1>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;

        case 3:
            interval=(pbbox[2].z - pbbox[1].z)/pslices;

            if(!interval)
            {   
                myundo=0;
                lyrsetfg(pfg);
                return;
            }

            editbegin();
                for(i=1;i<=pslices - 1;i++)
                {
                    corner1=addpoint(<mylo.x - 1,mylo.y - 1,mylo.z +interval*i>);
                    corner2=addpoint(<myhi.x + 1,mylo.y - 1,mylo.z +interval*i>);
                    corner3=addpoint(<myhi.x + 1,myhi.y + 1,mylo.z +interval*i>);
                    corner4=addpoint(<mylo.x - 1,myhi.y + 1,mylo.z +interval*i>);
                    mypoly=@corner1,corner2,corner3,corner4@;
                    addpolygon(mypoly);
                }
            editend();

        break;
    }


    lyrsetfg(pfg);
    lyrsetbg(pbg);
    selpolygon(SET,POLYID,mypolys);
    soliddrill(SLICE);
    lyrsetfg(pbg);
    delete();
    lyrsetfg(pfg);

}

